/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef _NT4GA_PCI_TA_TG_H_
#define _NT4GA_PCI_TA_TG_H_

#include <stdint.h>

#define TA_TG_DBG_SHOW_SUMMARY (1)

#define TG_NUM_PACKETS (8)
#define TG_PKT_SIZE (2048*1)
#define TG_AREA_SIZE (TG_NUM_PACKETS*TG_PKT_SIZE)

#define TG_DELAY (200000) /* usec */

/* Struct predefinitions */
struct AdapterInfo_s;
struct NthwHif_EndPointCounters;

struct Nt4gaPciTaTg_s
{
  struct NthwPciRdTg* mpNthwPciRdTg;
  struct NthwPciWrTg* mpNthwPciWrTg;
  struct NthwPciTa* mpNthwPciTa;
};

typedef struct Nt4gaPciTaTg_s Nt4gaPciTaTg_t;
typedef struct Nt4gaPciTaTg_s Nt4gaPciTaTg;

#if 0
Nt4gaPciTaTg_t* Nt4gaPciTaTg_new(void);
void Nt4gaPciTaTg_delete(Nt4gaPciTaTg_t* p);
#endif

int Nt4gaPciTaTg_init(struct AdapterInfo_s *pAdapterInfo);

#if 0
int Nt4gaPciTaTg_ta_read_control_enable(Nt4gaPciTaTg_t* p, uint32_t* enable);
int Nt4gaPciTaTg_ta_write_control_enable(Nt4gaPciTaTg_t* p, uint32_t enable);

int Nt4gaPciTaTg_ta_read_packet_good(Nt4gaPciTaTg_t* p, uint32_t* pData);
int Nt4gaPciTaTg_ta_read_packet_bad(Nt4gaPciTaTg_t* p, uint32_t* pData);
int Nt4gaPciTaTg_ta_read_length_error(Nt4gaPciTaTg_t* p, uint32_t* pData);
int Nt4gaPciTaTg_ta_read_payload_error(Nt4gaPciTaTg_t* p, uint32_t* pData);
#endif
int Nt4gaPciTaTg_MeasureThroughputRun(struct AdapterInfo_s* pAdapterInfo, struct NthwHif_EndPointCounters* pri, struct NthwHif_EndPointCounters* sla);
int Nt4gaPciTaTg_MeasureThroughputMain(struct AdapterInfo_s* pAdapterInfo, const uint8_t numaNode, const int direction, const int nPktSize, const int nBatchCount, const int nDelay);

#endif /* _NT4GA_PCI_TA_TG_H_ */
