/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_FPGA_H__
#define __NTHW_FPGA_H__

#include "nthw_drv.h"

#include "nthw_fpga_model.h"

#include "nthw_rac.h"
#include "nthw_iic.h"

#include "nthw_si5338.h"
#include "nthw_stat.h"

#include "nthw_fpga_rst.h"

#include "nthw_fpga_nt200a0x.h"
#include "nthw_fpga_nt400dxx.h"
#include "nthw_fpga_nt50b0x.h"

#include "nthw_dbs.h"
#include "nthw_mcu.h"

int nthw_fpga_init(struct FpgaInfo_s* pFpgaInfo);
int NthwFpga_shutdown(struct FpgaInfo_s* pFpgaInfo);

int NthwFpga_get_param_info(struct FpgaInfo_s* pFpgaInfo, nthw_fpga_t* pFpga);

int NthwFpga_avr_probe(nthw_fpga_t* pFpga, const int nInstanceNo);

int NthwFpga_iic_scan(nthw_fpga_t* pFpga, const int nInstanceNoBegin, const int nInstanceNoEnd);

int NthwFpga_iic_read_byte(nthw_fpga_t* pFpga, const int nInstanceNo, const uint8_t nDevAddr, const uint8_t nRegAddr);
int NthwFpga_iic_write_byte(nthw_fpga_t* pFpga, const int nInstanceNo, const uint8_t nDevAddr, const uint8_t nRegAddr, uint8_t val);

int NthwFpga_silabs_detect(nthw_fpga_t* pFpga, const int nInstanceNo, const int nDevAddr, const int nPageRegAddr);

int NthwFpga_si5338_clock_synth_init_Fmt0(nthw_fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt0_t* pClkProfile, const int nClkProfileRecCnt);
int NthwFpga_si5340_clock_synth_init_Fmt1(nthw_fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt1_t* pClkProfile, const int nClkProfileRecCnt);
int NthwFpga_si5340_clock_synth_init_Fmt2(nthw_fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt2_t* pClkProfile, const int nClkProfileRecCnt);

#endif /* __NTHW_FPGA_H__ */
