/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_FPGA_RST_NT400D1X_H__
#define __NTHW_FPGA_RST_NT400D1X_H__

#include "nthw_drv.h"
#include "nthw_fpga_model.h"

struct NthwFpga_rst_nt400dxx
{
  int nFpgaProductId;
  int nFpgaVersion;
  int nFpgaRevision;
  int nHwId;
  bool mbIsNT400D11;

  nthw_field_t* pFldRstSys;
  nthw_field_t* pFldRstDdr4;
  nthw_field_t* pFldRstPhyFtile;

  nthw_field_t* pFldStatDdr4CalibComplete;
  nthw_field_t* pFldStatPhyFtileRstDone;
  nthw_field_t* pFldStatPhyFtileRdy;

  nthw_field_t* pFldLatchDdr4CalibComplete;
  nthw_field_t* pFldLatchPhyFtileRstDone;
  nthw_field_t* pFldLatchPhyFtileRdy;
};

typedef struct NthwFpga_rst_nt400dxx NthwFpga_rst_nt400dxx_t;

int nthw_fpga_rst_nt400dxx_init(struct FpgaInfo_s* pFpgaInfo);
int nthw_fpga_rst_nt400dxx_reset(struct FpgaInfo_s* pFpgaInfo);

int nthw_pga_rst9569_setup(nthw_fpga_t* pFpga, struct NthwFpga_rst_nt400dxx* const p);
void nthw_fpga_rst9569_set_default_rst_values(struct NthwFpga_rst_nt400dxx* const p);
void nthw_fpga_rst9569_sys_rst(struct NthwFpga_rst_nt400dxx* const p, uint32_t val);
void nthw_fpga_rst9569_ddr4_rst(struct NthwFpga_rst_nt400dxx* const p, uint32_t val);
void nthw_fpga_rst9569_phy_ftile_rst(struct NthwFpga_rst_nt400dxx* const p, uint32_t val);
bool nthw_fpga_rst9569_get_ddr4_calib_complete_stat(struct NthwFpga_rst_nt400dxx* const p);
bool nthw_fpga_rst9569_get_phy_ftile_rst_done_stat(struct NthwFpga_rst_nt400dxx* const p);
bool nthw_fpga_rst9569_get_phy_ftile_rdy_stat(struct NthwFpga_rst_nt400dxx* const p);
bool nthw_fpga_rst9569_get_ddr4_calib_complete_latch(struct NthwFpga_rst_nt400dxx* const p);
void nthw_fpga_rst9569_set_ddr4_calib_complete_latch(struct NthwFpga_rst_nt400dxx* const p, uint32_t val);

#endif /* __NTHW_FPGA_RST_NT400D1X_H__ */
