/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_GFG_H_
#define NTHW_GFG_H_

struct NthwGfg
{

  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModGfg;
  int mnInstance;

  int mnParamGfgPresent;

  nthw_field_t* mpaFldCtrlEnable[8];
  nthw_field_t* mpaFldCtrlMode[8];
  nthw_field_t* mpaFldCtrlPrbsEn[8];
  nthw_field_t* mpaFldCtrlSize[8];
  nthw_field_t* mpaFldStreamIdVal[8];
  nthw_field_t* mpaFldSizeMask[8];
  nthw_field_t* mpaFldBurstSizeVal[8];
};

typedef struct NthwGfg NthwGfg_t;
typedef struct NthwGfg NthwGfg;

NthwGfg_t* NthwGfg_new(void);
void NthwGfg_delete(NthwGfg_t* p);
int NthwGfg_init(NthwGfg_t* p, nthw_fpga_t* pFpga, int nInstance);

int NthwGfg_getEnable(NthwGfg_t* p, const int nIntfNo);
int NthwGfg_setEnable(NthwGfg_t* p, const int nIntfNo, const bool enable);

int NthwGfg_Start(NthwGfg_t* p, const int nIntfNo, const int nFrameCount, const int nFrameSize, const int nFrameFillMode, const int nFrameStreamId);
int NthwGfg_Stop(NthwGfg_t* p, const int nIntfNo);
int NthwGfg_Setup(NthwGfg_t* p, const size_t nIntfNo, const int nEnable, const int nFrameCount, const int nFrameSize, const int nFrameFillMode, const int nFrameStreamId);

#endif /* NTHW_GFG_H_ */
