/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_GPIO_SFPP_H_
#define NTHW_GPIO_SFPP_H_

struct NthwGpioSfpp
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModGpioSfpp;
  int mnInstance;

  nthw_register_t* mpGpioSfppCfg;
  nthw_field_t* mpGpioSfppCfgAbs;
  nthw_field_t* mpGpioSfppCfgRxlos;
  nthw_field_t* mpGpioSfppCfgTxfault;
  nthw_field_t* mpGpioSfppCfgTxdisable;
  nthw_field_t* mpGpioSfppCfgRs;

  nthw_register_t* mpGpioSfppGpio;
  nthw_field_t* mpGpioSfppGpioAbs;
  nthw_field_t* mpGpioSfppGpioRxlos;
  nthw_field_t* mpGpioSfppGpioTxfault;
  nthw_field_t* mpGpioSfppGpioTxdisable;
  nthw_field_t* mpGpioSfppGpioRs;
};

typedef struct NthwGpioSfpp NthwGpioSfpp_t;
typedef struct NthwGpioSfpp NthwGpioSfpp;

NthwGpioSfpp_t* NthwGpioSfpp_new(void);
void NthwGpioSfpp_delete(NthwGpioSfpp_t* p);
int NthwGpioSfpp_init(NthwGpioSfpp_t* p, nthw_fpga_t* pFpga, int nInstance);

bool NthwGpioSfpp_isSfppPresent(NthwGpioSfpp_t* p);
bool NthwGpioSfpp_isRxLos(NthwGpioSfpp_t* p);
void NthwGpioSfpp_setTxFault(NthwGpioSfpp_t* p, bool fault);
void NthwGpioSfpp_setTxDisable(NthwGpioSfpp_t* p, bool disable);
void NthwGpioSfpp_setRs(NthwGpioSfpp_t* p, uint8_t rs);

#endif /* NTHW_GPIO_SFPP_H_ */
