/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_IGAM_H__
#define __NTHW_IGAM_H__

#include "nthw_fpga_model.h"

struct nt_igam
{
  nthw_fpga_t* mpFpga;

  nthw_module_t* mpModIgam;

  int mnIgamInstance;

  nthw_register_t* mpRegBase;
  nthw_field_t* mpFldBasePtr;
  nthw_field_t* mpFldBaseBusy;
  nthw_field_t* mpFldBaseCmd;

  nthw_register_t* mpRegData;
  nthw_field_t* mpFldDataData;
};

typedef struct nt_igam nthw_igam_t;
typedef struct nt_igam NthwIgam;

nthw_igam_t* nthw_igam_new(void);
void nthw_igam_delete(nthw_igam_t* p);
int nthw_igam_init(nthw_igam_t *p, nthw_fpga_t *pFpga, int mnIgamInstance);
uint32_t nthw_igam_read(nthw_igam_t *p, uint32_t address);
void nthw_igam_write(nthw_igam_t *p, uint32_t address, uint32_t data);


#endif /*  __NTHW_IGAM_H__ */
