/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_MAC1_H_
#define NTHW_MAC1_H_

struct NthwMac1g {
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModMac1g;
  int mnInstance;

  /* Control */
  nthw_field_t*    mpRxEnable;
  nthw_field_t*    mpRxPauseEnable;
  nthw_field_t*    mpTxEnable;
  nthw_field_t*    mpFldTsEop;
  nthw_field_t*    mpRxMinFrame;
  nthw_field_t*    mpTxPauseEnable;
  nthw_field_t*    mpStrEnable;
  nthw_field_t*    mpSpeed;

  /* MAC Address */
  nthw_field_t*    mpMacAddrLower;
  nthw_field_t*    mpMacAddrUpper;
};

typedef struct NthwMac1g NthwMac1g_t;
typedef struct NthwMac1g NthwMac1g;

NthwMac1g_t* NthwMac1g_new(void);
void NthwMac1g_delete(NthwMac1g_t* p);
int NthwMac1g_init(NthwMac1g_t *p, nthw_fpga_t* pFpga, int nInstance);

void NthwMac1g_EnableStretch(NthwMac1g_t* p, bool enable);
void NthwMac1g_setRxEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTxEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTsEop(NthwMac1g_t* p, uint32_t bitEop);
void NthwMac1g_setRxMinFrame(NthwMac1g_t* p, uint32_t min_rx_frame);
void NthwMac1g_setRxPauseEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTxPauseEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_SetMacAddr(NthwMac1g_t* p, uint8_t macAddr[6]);
void NthwMac1g_SetSpeed(NthwMac1g_t* p, uint8_t speed);

#endif /* NTHW_MAC1_H_ */
