/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_MSK_H_
#define NTHW_MSK_H_

struct NthwMsk
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModMsk;
  int mnInstance;

  int mnMskCategories;

  nthw_register_t* reg_msk_rcp_ctrl;
  nthw_field_t* fld_msk_rcp_ctrl_adr;
  nthw_field_t* fld_msk_rcp_ctrl_cnt;

  nthw_register_t* reg_msk_rcp_data;
  nthw_field_t* fld_msk_rcp_data_mask_en0;
  nthw_field_t* fld_msk_rcp_data_mask_dyn0;
  nthw_field_t* fld_msk_rcp_data_mask_ofs0;
  nthw_field_t* fld_msk_rcp_data_mask_len0;
  nthw_field_t* fld_msk_rcp_data_mask_en1;
  nthw_field_t* fld_msk_rcp_data_mask_dyn1;
  nthw_field_t* fld_msk_rcp_data_mask_ofs1;
  nthw_field_t* fld_msk_rcp_data_mask_len1;
  nthw_field_t* fld_msk_rcp_data_mask_en2;
  nthw_field_t* fld_msk_rcp_data_mask_dyn2;
  nthw_field_t* fld_msk_rcp_data_mask_ofs2;
  nthw_field_t* fld_msk_rcp_data_mask_len2;
  nthw_field_t* fld_msk_rcp_data_mask_en3;
  nthw_field_t* fld_msk_rcp_data_mask_dyn3;
  nthw_field_t* fld_msk_rcp_data_mask_ofs3;
  nthw_field_t* fld_msk_rcp_data_mask_len3;
};

typedef struct NthwMsk NthwMsk_t;
typedef struct NthwMsk NthwMsk;

NthwMsk_t* NthwMsk_new(void);
void NthwMsk_delete(NthwMsk_t* p);
int NthwMsk_init(NthwMsk_t *p, nthw_fpga_t* pFpga, int nInstance);

int NthwMsk_setup(NthwMsk_t* p);

#endif /* NTHW_MSK_H_ */
