/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_PCI_RD_TG_H__
#define __NTHW_PCI_RD_TG_H__

struct NthwPciRdTg
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPciRdTg;
  int mnInstance;

  int mnParamPciTaTgPresent;

  nthw_register_t* mpRegPciRdTgRdData0;
  nthw_field_t* mpFldPciRdTgPhysAddrLow;

  nthw_register_t* mpRegPciRdTgRdData1;
  nthw_field_t* mpFldPciRdTgPhysAddrHigh;

  nthw_register_t* mpRegPciRdTgRdData2;
  nthw_field_t* mpFldPciRdTgReqSize;
  nthw_field_t* mpFldPciRdTgReqHid;
  nthw_field_t* mpFldPciRdTgWait;
  nthw_field_t* mpFldPciRdTgWrap;

  nthw_register_t* mpRegPciRdTgRdAddr;
  nthw_field_t* mpFldPciRdTgRamAddr;

  nthw_register_t* mpRegPciRdTgRdRun;
  nthw_field_t* mpFldPciRdTgRunIteration;

  nthw_register_t* mpRegPciRdTgRdCtrl;
  nthw_field_t* mpFldPciRdTgCtrlRdy;
};

typedef struct NthwPciRdTg NthwPciRdTg_t;
typedef struct NthwPciRdTg NthwPciRdTg;

NthwPciRdTg_t* NthwPciRdTg_new(void);
void NthwPciRdTg_delete(NthwPciRdTg_t* p);
int NthwPciRdTg_init(NthwPciRdTg_t* p, nthw_fpga_t* pFpga, int nInstance);

void NthwPciRdTg_setPhysAddr(NthwPciRdTg_t* p, uint64_t nPhysAddr);
void NthwPciRdTg_setRamAddr(NthwPciRdTg_t* p, int nRamAddr);
void NthwPciRdTg_setRamData(NthwPciRdTg_t* p, uint32_t reqSize, bool wait, bool wrap);
void NthwPciRdTg_setRun(NthwPciRdTg_t* p, int nIterations);
uint32_t NthwPciRdTg_getCtrlRdy(NthwPciRdTg_t* p);

#endif /* __NTHW_PCI_RD_TG_H__ */
