/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_PCI_WR_TG_H__
#define __NTHW_PCI_WR_TG_H__

struct NthwPciWrTg
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPciWrTg;
  int mnInstance;

  int mnParamPciTaTgPresent;

  nthw_register_t* mpRegPciWrTgData0;
  nthw_field_t* mpFldPciWrTgPhysAddrLow;

  nthw_register_t* mpRegPciWrTgData1;
  nthw_field_t* mpFldPciWrTgPhysAddrHigh;

  nthw_register_t* mpRegPciWrTgData2;
  nthw_field_t* mpFldPciWrTgReqSize;
  nthw_field_t* mpFldPciWrTgReqHid;
  nthw_field_t* mpFldPciWrTgIncMode;
  nthw_field_t* mpFldPciWrTgWait;
  nthw_field_t* mpFldPciWrTgWrap;

  nthw_register_t* mpRegPciWrTgAddr;
  nthw_field_t* mpFldPciWrTgRamAddr;

  nthw_register_t* mpRegPciWrTgRun;
  nthw_field_t* mpFldPciWrTgRunIteration;

  nthw_register_t* mpRegPciWrTgCtrl;
  nthw_field_t* mpFldPciWrTgCtrlRdy;

  nthw_register_t* mpRegPciWrTgSeq;
  nthw_field_t* mpFldPciWrTgSeqSequence;
};

typedef struct NthwPciWrTg NthwPciWrTg_t;
typedef struct NthwPciWrTg NthwPciWrTg;

NthwPciWrTg_t* NthwPciWrTg_new(void);
void NthwPciWrTg_delete(NthwPciWrTg_t* p);
int NthwPciWrTg_init(NthwPciWrTg_t* p, nthw_fpga_t* pFpga, int nInstance);

void NthwPciWrTg_setPhysAddr(NthwPciWrTg_t* p, uint64_t nPhysAddr);
void NthwPciWrTg_setRamAddr(NthwPciWrTg_t* p, int nRamAddr);
void NthwPciWrTg_setRamData(NthwPciWrTg_t* p, uint32_t reqSize, bool wait, bool wrap, bool inc);
void NthwPciWrTg_setRun(NthwPciWrTg_t* p, int nIterations);
uint32_t NthwPciWrTg_getCtrlRdy(NthwPciWrTg_t* p);

#endif /* __NTHW_PCI_WR_TG_H__ */
