/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PHY10G_H_
#define NTHW_PHY10G_H_

struct NthwPhy10g
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPhy10g;
  int mnInstance;

  nthw_field_t* mpLinkSummaryAbs;
  nthw_field_t* mpLinkSummaryNtLinkState;
  nthw_field_t* mpLinkSummaryRes;
  nthw_field_t* mpLinkSummaryLinkDownCnt;

  nthw_field_t* mpCtrlSoftReset;
  nthw_field_t* mpCtrlLinkupLatency;
  nthw_field_t* mpCtrlForceLinkDown;
  nthw_field_t* mpCtrlLineLoopback;
  nthw_field_t* mpCtrlHostLoopback;

  nthw_field_t* mpCoreConfPmaLoopback;
  nthw_field_t* mpCoreConfPmaReset;
  nthw_field_t* mpCoreConfGlobalTxDisable;
  nthw_field_t* mpCoreConfPcsLoopback;
  nthw_field_t* mpCoreConfPcsReset;
  nthw_field_t* mpCoreConfDataPattSel;
  nthw_field_t* mpCoreConfTestPattSel;
  nthw_field_t* mpCoreConfRxTestPattEn;
  nthw_field_t* mpCoreConfTxTestPattEn;
  nthw_field_t* mpCoreConfPrbs31TxEn;
  nthw_field_t* mpCoreConfPrbs31RxEn;
  nthw_field_t* mpCoreConfSetPmaLinkStatus;
  nthw_field_t* mpCoreConfClearPmaPmdLinkFaults;
  nthw_field_t* mpCoreConfSetPcsLinkStatus;
  nthw_field_t* mpCoreConfClearPcsLinkFaults;
  nthw_field_t* mpCoreConfClearPcsStatus2;
  nthw_field_t* mpCoreConfClearTestPattErrCount;
  nthw_field_t* mpCoreConfNtLinkupLatency;
  nthw_field_t* mpCoreConfNtForceLinkDown;
  nthw_field_t* mpCoreConfTxDisable;

  nthw_field_t* mpCoreStatPcsBlockLock;
  nthw_field_t* mpCoreStatPmaReset;
  nthw_field_t* mpCoreStatPmaPmdLinkStat;
  nthw_field_t* mpCoreStatPmaPmdRxFault;
  nthw_field_t* mpCoreStatPmaPmdTxFault;
  nthw_field_t* mpCoreStatRxSigDet;
  nthw_field_t* mpCoreStatPcsRxLinkStatus;
  nthw_field_t* mpCoreStatPcsRxFault;
  nthw_field_t* mpCoreStatPcsTxFault;
  nthw_field_t* mpCoreStatPcsRxLocked;
  nthw_field_t* mpCoreStatPcsHiber;
  nthw_field_t* mpCoreStatTengPcsRxLinkStatus;
  nthw_field_t* mpCoreStatNtLinkState;
  nthw_field_t* mpCoreStatPcsErrBlockCount;
  nthw_field_t* mpCoreStatPcsBerCount;
  nthw_field_t* mpCoreStatPcsRxHiberLh;
  nthw_field_t* mpCoreStatPcsRxLockedLl;
  nthw_field_t* mpCoreStatPcsTestPattErrCount;
  nthw_field_t* mpCoreStatPcsReset;

  nthw_field_t* mpGpioPwrEn;
  nthw_field_t* mpGpioAbs;
  nthw_field_t* mpGpioRxLos;
  nthw_field_t* mpGpioTxFault;
  nthw_field_t* mpGpioLedMode;
  nthw_field_t* mpGpioLedModeNim;
  nthw_field_t* mpGpioLedModePhy;

  nthw_field_t* mpIntEn;
  nthw_field_t* mpIntMaxPace;

  nthw_field_t* mpGtCtrlEyescanreset;
  nthw_field_t* mpGtCtrlEyescantrigger;
  nthw_field_t* mpGtCtrlRxcdrhold;
  nthw_field_t* mpGtCtrlTxprbsforceerr;
  nthw_field_t* mpGtCtrlRxrate;
  nthw_field_t* mpGtCtrlTxpmareset;
  nthw_field_t* mpGtCtrlRxpmareset;
  nthw_field_t* mpGtCtrlRxdfelpmreset;
  nthw_field_t* mpGtCtrlTxprecursor;
  nthw_field_t* mpGtCtrlTxpostcursor;
  nthw_field_t* mpGtCtrlTxdiffctrl;
  nthw_field_t* mpGtCtrlRxlpmen;

  nthw_field_t* mpGtStatEyescandataerror;
  nthw_field_t* mpGtStatTxbufstatus;
  nthw_field_t* mpGtStatTxresetdone;
  nthw_field_t* mpGtStatRxpmaresetdone;
  nthw_field_t* mpGtStatRxresetdone;
  nthw_field_t* mpGtStatRxbufstatus;
  nthw_field_t* mpGtStatRxprbserr;
  nthw_field_t* mpGtStatDmonitorout;

  nthw_field_t* mpTsComp;
};

typedef struct NthwPhy10g NthwPhy10g_t;
typedef struct NthwPhy10g NthwPhy10g;

NthwPhy10g_t* NthwPhy10g_new(void);
void NthwPhy10g_delete(NthwPhy10g_t* p);
int NthwPhy10g_init(NthwPhy10g_t *p, nthw_fpga_t* pFpga, int nInstance);

void NthwPhy10g_moduleDetect(NthwPhy10g_t* p, bool* modDetect);
void NthwPhy10g_nimPower(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_linkStatus(NthwPhy10g_t* p, bool* pCurrent, bool* latched);
void NthwPhy10g_resetLatchedBits(NthwPhy10g_t* p);
void NthwPhy10g_nimTxlaser(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_getTxlaser(NthwPhy10g_t* p, bool *pEnable);
void NthwPhy10g_signalDetect(NthwPhy10g_t* p, bool *sigDetect);
void NthwPhy10g_portStatus(NthwPhy10g_t* p, bool* pCurrent, bool* modDetect, uint32_t* linkDownCnt);

void NthwPhy10g_setLedMode(NthwPhy10g_t* p, uint8_t mode);
void NthwPhy10g_setPmaLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_setPcsLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_setTxEye(NthwPhy10g_t* p, uint8_t pre, uint8_t post, uint8_t diff);
void NthwPhy10g_forceLinkDown(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_TxDisable(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_getTxDisable(NthwPhy10g_t* p, bool *pEnable);
void NthwPhy10g_SetHostLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_SetLineLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_SetTsCompRx(NthwPhy10g_t* p, uint16_t rxDly);

#endif /* NTHW_PHY3S10G_H_ */
