/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PM_H_
#define NTHW_PM_H_

struct NthwPm
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPm;
  int mnInstance;

  nthw_register_t* mpRegCtrl; /* PM_CTRL */
  nthw_field_t* mpFldCtrlSwCleanDone; /* PM_CTRL_SW_CLEAN_DONE */

  nthw_register_t* mpRegRxTxSlowPtrBlkInterval; /* PM_RX_TX_SLOW_POINTER_BLOCK_INTERVAL */
  nthw_field_t* mpFldRxTxSlowPtrBlkIntervalData; /* PM_RX_TX_SLOW_POINTER_BLOCK_INTERVAL_D */

  nthw_register_t* mpRegTxReadPtrBlkInterval; /* PM_TX_READ_POINTER_BLOCK_INTERVAL */
  nthw_field_t* mpFldTxReadPtrBlkIntervalData; /* PM_TX_READ_POINTER_BLOCK_INTERVAL_D */

  nthw_register_t* mpRegRxTxFastMemCtrl; /* PM_RXTX_FAST_MEM_CTRL */
  nthw_field_t* mpFldRxTxFastMemCtrlAdr; /* PM_RXTX_FAST_MEM_CTRL_A */
  nthw_field_t* mpFldRxTxFastMemCtrlCnt; /* PM_RXTX_FAST_MEM_CTRL_CNT */

  nthw_register_t* mpRegRxTxFastMemData; /* PM_RXTX_FAST_MEM_DATA */
  nthw_field_t* mpFldRxTxFastMemDataEntry; /* PM_RXTX_FAST_MEM_DATA_ENTRY */
  nthw_field_t* mpFldRxTxFastMemDataHostBuffer; /* PM_RXTX_FAST_MEM_DATA_HOST_BUFFER */
  nthw_field_t* mpFldRxTxFastMemDataRxTx; /* PM_RXTX_FAST_MEM_DATA_RX_TX */
  nthw_field_t* mpFldRxTxFastMemDataVld; /* PM_RXTX_FAST_MEM_DATA_VLD */
  nthw_field_t* mpFldRxTxFastMemDataBank; /* PM_RXTX_FAST_MEM_DATA_BANK */

  nthw_register_t* mpRegRxTxSlowMemCtrl; /* PM_RXTX_SLOW_MEM_CTRL */
  nthw_field_t* mpFldRxTxSlowMemCtrlAdr; /* PM_RXTX_SLOW_MEM_CTRL_A */
  nthw_field_t* mpFldRxTxSlowMemCtrlCnt; /* PM_RXTX_SLOW_MEM_CTRL_CNT */

  nthw_register_t* mpRegRxTxSlowMemData; /* PM_RXTX_SLOW_MEM_DATA */
  nthw_field_t* mpFldRxTxSlowMemDataEntry; /* PM_RXTX_SLOW_MEM_DATA_ENTRY */
  nthw_field_t* mpFldRxTxSlowMemDataHostBuffer; /* PM_RXTX_SLOW_MEM_DATA_HOST_BUFFER */
  nthw_field_t* mpFldRxTxSlowMemDataRxTx; /* PM_RXTX_SLOW_MEM_DATA_RX_TX */
  nthw_field_t* mpFldRxTxSlowMemDataVld; /* PM_RXTX_SLOW_MEM_DATA_VLD */
  nthw_field_t* mpFldRxTxSlowMemDataBank; /* PM_RXTX_SLOW_MEM_DATA_BANK */

  nthw_register_t* mpRegRxTxFastPtrBlkInterval; /* PM_RX_TX_FAST_POINTER_BLOCK_INTERVAL */
  nthw_field_t* mpFldRxTxFastPtrBlkIntervalData; /* PM_RX_TX_FAST_POINTER_BLOCK_INTERVAL_D */

  nthw_register_t* mpRegPbiMemCtrl; /* PM_PBI_MEM_CTRL */
  nthw_field_t* mpFldPbiMemCtrlAdr; /* PM_PBI_MEM_CTRL_A */
  nthw_field_t* mpFldPbiMemCtrlCnt; /* PM_PBI_MEM_CTRL_CNT */

  nthw_register_t* mpRegPbiMemData; /* PM_PBI_MEM_DATA */
  nthw_field_t* mpFldPbiMemDataPhyAddr; /* PM_PBI_MEM_DATA_PHYADDR */
  nthw_field_t* mpFldPbiMemDataSize; /* PM_PBI_MEM_DATA_SIZE */

  nthw_register_t* mpRegRxWpMemCtrl; /* PM_RXWP_MEM_CTRL */
  nthw_field_t* mpFldRxWpMemCtrlAdr; /* PM_RXWP_MEM_CTRL_A */
  nthw_field_t* mpFldRxWpMemCtrlCnt; /* PM_RXWP_MEM_CTRL_CNT */

  nthw_register_t* mpRegRxWpMemData; /* PM_RXWP_MEM_DATA */
  nthw_field_t* mpFldRxWpMemDataHostBuffer; /* PM_RXWP_MEM_DATA_HOST_BUFFER */
  nthw_field_t* mpFldRxWpMemDataVld; /* PM_RXWP_MEM_DATA_VLD */
  nthw_field_t* mpFldRxWpMemDataBank; /* PM_RXWP_MEM_DATA_BANK */
  nthw_field_t* mpFldRxWpMemDataEntry; /* PM_RXWP_MEM_DATA_ENTRY */

  nthw_register_t* mpRegTxRpMemCtrl; /* PM_TXRP_MEM_CTRL */
  nthw_field_t* mpFldTxRpMemCtrlAdr; /* PM_TXRP_MEM_CTRL_A */
  nthw_field_t* mpFldTxRpMemCtrlCnt; /* PM_TXRP_MEM_CTRL_CNT */

  nthw_register_t* mpRegTxRpMemData; /* PM_TXRP_MEM_DATA */
  nthw_field_t* mpFldTxRpMemDataHostBuffer; /* PM_TXRP_MEM_DATA_HOST_BUFFER */
  nthw_field_t* mpFldTxRpMemDataVld; /* PM_TXRP_MEM_DATA_VLD */
  nthw_field_t* mpFldTxRpMemDataBank; /* PM_TXRP_MEM_DATA_BANK */
  nthw_field_t* mpFldTxRpMemDataEntry; /* PM_TXRP_MEM_DATA_ENTRY */

  nthw_register_t* mpRegPointerBanks; /* PM_POINTER_BANKS */
  nthw_field_t* mpFldPointerBanksData; /* PM_POINTER_BANKS_D */

  nthw_register_t* mpRegHbSizeRxThreshold; /* PM_HB_SIZE_RX_THRESHOLD */
  nthw_field_t* mpFldHbSizeRxThresholdData; /* PM_HB_SIZE_RX_THRESHOLD_D */

  nthw_register_t* mpRegHbSizeRxMemData; /* PM_HB_SIZE_RX_MEM_DATA */
  nthw_field_t* mpFldHbSizeRxMemDataSize; /* PM_HB_SIZE_RX_MEM_DATA_SIZE */

  nthw_register_t* mpRegHbSizeRxMemCtrl; /* PM_HB_SIZE_RX_MEM_CTRL */
  nthw_field_t* mpFldHbSizeRxMemCtrlAdr; /* PM_HB_SIZE_RX_MEM_CTRL_A */
  nthw_field_t* mpFldHbSizeRxMemCtrlCnt; /* PM_HB_SIZE_RX_MEM_CTRL_CNT */

  nthw_register_t* mpRegRxWritePtrBlkInterval; /* PM_RX_WRITE_POINTER_BLOCK_INTERVAL */
  nthw_field_t* mpFldRxWritePtrBlkIntervalData; /* PM_RX_WRITE_POINTER_BLOCK_INTERVAL_D */

  nthw_register_t* mpRegHbSizeTxThreshold; /* PM_HB_SIZE_TX_THRESHOLD */
  nthw_field_t* mpFldHbSizeTxThresholdData; /* PM_HB_SIZE_TX_THRESHOLD_D */

  nthw_register_t* mpRegRxReader; /* PM_RX_READER */
  nthw_field_t* mpFldRxReaderMask; /* PM_RX_READER_MASK */

  nthw_register_t* mpRegRxBlockedStatus; /* PM_RX_BLOCKED_STATUS */
  nthw_field_t* mpFldRxBlockedStatusData; /* PM_RX_BLOCKED_STATUS_D */

  nthw_register_t* mpRegRxBlockedStatusHi; /* PM_RX_BLOCKED_STATUS_HI */
  nthw_field_t* mpFldRxBlockedStatusHiData; /* PM_RX_BLOCKED_STATUS_HI_D */
};

typedef struct NthwPm NthwPm_t;
typedef struct NthwPm NthwPm;

NthwPm_t* NthwPm_new(void);
void NthwPm_delete(NthwPm_t* p);
int NthwPm_init(NthwPm_t* p, nthw_fpga_t* pFpga, int nInstance);

void NthwPm_setCtrlSwCleanDone(NthwPm_t* p, uint32_t val);

void NthwPm_setPointerBanks(NthwPm_t* p, uint32_t val);

void NthwPm_setHbSizeRxTreshold(NthwPm_t* p, uint32_t val);

void NthwPm_setRxWritePtrBlkInterval(NthwPm_t* p, uint32_t val);
void NthwPm_setTxReadPtrBlkInterval(NthwPm_t* p, uint32_t val);

void NthwPm_setRxTxSlowPtrBlkInterval(NthwPm_t* p, uint32_t val);
void NthwPm_setRxTxFastPtrBlkInterval(NthwPm_t* p, uint32_t val);

void NthwPm_setRxTxSlowMem(NthwPm_t* p, uint32_t addr, int entry, int bank, int hb, int rxtx, int vld);
void NthwPm_setRxTxFastMem(NthwPm_t* p, uint32_t addr, int entry, int bank, int hb, int rxtx, int vld);

void NthwPm_setRxReaderMask(NthwPm_t* p, uint32_t* data, int len);

void NthwPm_getRxBlockedStatusMask(NthwPm_t* p, uint32_t* data, int len);

void NthwPm_setHbSizeRx(NthwPm_t* p, uint32_t addr, uint64_t size);

void NthwPm_setPbi(NthwPm_t* p, uint32_t addr, uint64_t dmaAddr, uint32_t size);

void NthwPm_setRxWp(NthwPm_t* p, uint32_t addr, int bank, int entry, int hb, int vld);

void NthwPm_setTxRp(NthwPm_t* p, uint32_t addr, int bank, int entry, int hb, int vld);

#endif /* NTHW_PM_H_ */
