/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PRM_NT400DXX_H_
#define NTHW_PRM_NT400DXX_H_

struct nt_prm_nt400dxx
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPrm;

  int mnInstance;

  nthw_register_t* mpRegRst;
  nthw_field_t* mpFldRstPeriph;
  nthw_field_t* mpFldRstPlatform;

};

typedef struct nt_prm_nt400dxx nthw_prm_nt400dxx_t;
typedef struct nt_prm_nt400dxx nt_prm_nt400dxx;

nthw_prm_nt400dxx_t* nthw_prm_nt400dxx_new(void);
void nthw_prm_nt400dxx_delete(nthw_prm_nt400dxx_t* p);
int nthw_prm_nt400dxx_init(nthw_prm_nt400dxx_t* p, nthw_fpga_t* pFpga, int nInstance);
void nthw_prm_nt400dxx_periph_rst(nthw_prm_nt400dxx_t* p, uint32_t val);
void nthw_prm_nt400dxx_platform_rst(nthw_prm_nt400dxx_t* p, uint32_t val);

#endif /* NTHW_PRM_NT400DXX_H_ */
