/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_SI5338_H__
#define __NTHW_SI5338_H__

#define SI5338_SUCCESS (0)
#define SI5338_TIMEOUT (666)
#define SI5338_FAILED  (999)

struct Si5338Data {
   unsigned char Reg_Addr;
   unsigned char Reg_Val;
   unsigned char Reg_Mask;
};

typedef struct Si5338Data Si5338Data_t;

struct NthwSi5338
{
  uint8_t mnIicAddr;
  NthwIic_t* mpNthwIic;
  int mnClkCfg;
};

typedef struct NthwSi5338 NthwSi5338_t;

NthwSi5338_t* NthwSi5338_new(void);
int NthwSi5338_init(NthwSi5338_t *p, NthwIic_t *pNthwIic, uint8_t nIicAddr);
void NthwSi5338_delete(NthwSi5338_t* p);

int NthwSi5338_config(NthwSi5338_t* p, const Si5338Data_t* pData, int dataCnt, uint8_t clkSrc, int clkCfg);

#endif /* __NTHW_SI5338_H__ */
