/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_SPIM_H__
#define __NTHW_SPIM_H__

struct NthwSpim
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModSpim;
  int mnInstance;

  nthw_register_t* mpReg_srr;
  nthw_field_t* mpFld_srr_rst;

  nthw_register_t* mpReg_cr;
  nthw_field_t* mpFld_cr_loop;
  nthw_field_t* mpFld_cr_en;
  nthw_field_t* mpFld_cr_txrst;
  nthw_field_t* mpFld_cr_rxrst;

  nthw_register_t* mpReg_sr;
  nthw_field_t* mpFld_sr_done;
  nthw_field_t* mpFld_sr_txempty;
  nthw_field_t* mpFld_sr_rxempty;
  nthw_field_t* mpFld_sr_txfull;
  nthw_field_t* mpFld_sr_rxfull;
  nthw_field_t* mpFld_sr_txlvl;
  nthw_field_t* mpFld_sr_rxlvl;

  nthw_register_t* mpReg_dtr;
  nthw_field_t* mpFld_dtr_dtr;

  nthw_register_t* mpReg_drr;
  nthw_field_t* mpFld_drr_drr;

  nthw_register_t* mpReg_cfg;
  nthw_field_t* mpFld_cfg_pre;

  nthw_register_t *mpReg_cfg_clk;
  nthw_field_t *mpFld_cfg_clk_mode;
};

typedef struct NthwSpim NthwSpim_t;
typedef struct NthwSpim NthwSpim;

NthwSpim_t* NthwSpim_new(void);
int NthwSpim_init(NthwSpim_t* p, nthw_fpga_t* pFpga, int nInstance);
void NthwSpim_delete(NthwSpim_t* p);

uint32_t NthwSpim_reset(NthwSpim_t* p);
uint32_t NthwSpim_enable(NthwSpim_t* p, bool bEnable);
uint32_t NthwSpim_get_tx_fifo_empty(NthwSpim_t* p, bool* pbEmpty);
uint32_t NthwSpim_write_tx_fifo(NthwSpim_t* p, uint32_t nData);

#endif /* __NTHW_SPIM_H__ */
