/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_TSM_H__
#define __NTHW_TSM_H__

struct NthwTsm
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModTsm;
  int mnInstance;

  nthw_field_t* mpFldConfigTsFormat;

  nthw_field_t* mpFldTimerCtrlTimerEnT0;
  nthw_field_t* mpFldTimerCtrlTimerEnT1;

  nthw_field_t* mpFldTimerTimerT0MaxCount;

  nthw_field_t* mpFldTimerTimerT1MaxCount;

  nthw_register_t* mpRegTsLo;
  nthw_field_t* mpFldTsLo;

  nthw_register_t* mpRegTsHi;
  nthw_field_t* mpFldTsHi;

  nthw_register_t* mpRegTimeLo;
  nthw_field_t* mpFldTimeLo;

  nthw_register_t* mpRegTimeHi;
  nthw_field_t* mpFldTimeHi;
};

typedef struct NthwTsm NthwTsm_t;
typedef struct NthwTsm NthwTsm;

NthwTsm_t* NthwTsm_new(void);
void NthwTsm_delete(NthwTsm_t* p);
int NthwTsm_init(NthwTsm_t *p, nthw_fpga_t* pFpga, int nInstance);

int NthwTsm_getTs(NthwTsm_t* p, uint64_t* pTs);
int NthwTsm_getTime(NthwTsm_t* p, uint64_t* pTime);
int NthwTsm_setTime(NthwTsm_t* p, uint64_t nTime);

int NthwTsm_setTimerT0Enable(NthwTsm_t* p, bool bEnable);
int NthwTsm_setTimerT0MaxCount(NthwTsm_t* p, uint32_t nTimerVal);
int NthwTsm_setTimerT1Enable(NthwTsm_t* p, bool bEnable);
int NthwTsm_setTimerT1MaxCount(NthwTsm_t* p, uint32_t nTimerVal);

int NthwTsm_setConfigTsFormat(NthwTsm_t* p, uint32_t nVal);

#endif /* __NTHW_TSM_H__ */
