/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_DEBUG_H_
#define NTHW_DEBUG_H_

#include <inttypes.h>
#include <stdint.h>

#include "nthw_fpga_model.h"

typedef int (*nthw_debug_cmd_ctl_func_t)(struct FpgaInfo_s* p_fpga_info, FILE* pfh, const char cmd, const int arg_cnt, uint64_t args[]);
int nthw_debug_cmd_ctl(struct FpgaInfo_s* p_fpga_info, FILE* pfh, const char cmd, const int arg_cnt, uint64_t args[]);
int nthw_debug_cmd_loop(struct FpgaInfo_s* p_fpga_info, nthw_debug_cmd_ctl_func_t p_func, int ifd, int ofd);
void* nthw_debug_reg_access_thread_fn(void* pVoidCtx);

int debug_only_nthw_read_data(struct FpgaInfo_s* p_fpga_info, int n_bus_type_id, uint32_t addr, uint32_t len, uint32_t* p_data);
int debug_only_nthw_write_data(struct FpgaInfo_s* p_fpga_info, int n_bus_type_id, uint32_t addr, uint32_t len, const uint32_t* p_data);

#endif /* NTHW_DEBUG_H_ */
