/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_STAT_H__
#define __NTHW_STAT_H__

struct NthwStat
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModStat;
  int mnInstance;

  int mnStatLayoutVersion;

  bool mbIsVswitch;
  bool mbHasTxStats;

  int mNbPhyPorts;
  int mNbNimPorts;

  int mNbRxPorts;
  int mNbTxPorts;

  int mNbRxHostBuffers;
  int mNbTxHostBuffers;

  int mDbsPresent;

  int mRxPortReplicate;

  int mNbColorCounters;

  int mNbRxHbCounters;
  int mNbTxHbCounters;

  int mNbRxPortCounters;
  int mNbTxPortCounters;

  int mNbCounters;

  nthw_field_t* mpFldDmaEna;
  nthw_field_t* mpFldCntClear;

  nthw_field_t* mpFldTxDisable;

  nthw_field_t* mpFldCntFreeze;

  nthw_field_t* mpFldStatToggleMissed;

  nthw_field_t* mpFldDmaLsb;
  nthw_field_t* mpFldDmaMsb;

  uint64_t mStatDmaPhysical;
  uint32_t* mpStatDmaVirtual;

  uint64_t lastTs;

#if 0
  union Timestamp {
    uint32_t w32[2];
    uint64_t w64;
  };
  Timestamp* mpTimestamp;
#endif
  uint64_t* mpTimestamp;
};

typedef struct NthwStat NthwStat_t;
typedef struct NthwStat NthwStat;

NthwStat_t* NthwStat_new(void);
int NthwStat_init(NthwStat_t *p, nthw_fpga_t *pFpga, int nInstance);
void NthwStat_delete(NthwStat_t* p);

int NthwStat_setDmaAddress(NthwStat_t* p, uint64_t statDmaPhysical, uint32_t* pStatDmaVirtual);
int NthwStat_trigger(NthwStat_t* p);

#endif /* __NTHW_STAT_H__ */
