/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef _AVR_SENSORS_H
#define _AVR_SENSORS_H

#include <stdint.h>

#include "sensors.h"
#include "avr_intf.h"
#include "ntavr.h"

struct nt_sensor_group* avr_sensor_init(Nthw_Spi_V3_t *s_spi,
                                        uint8_t mAdapterNo, const char* pName,
                                        enum NtSensorSource_e ssrc, enum NtSensorType_e type,
                                        unsigned int index,
                                        enum sensor_mon_device avrDev, uint8_t avrDevReg,
                                        enum sensor_mon_endian end, enum sensor_mon_sign si,
                                        int (*conv_func)(uint32_t),
                                        uint16_t mask);

#endif /* _AVR_SENSORS_H */
