# Napatech DPDK patch #
The Napatech DPDK patch is needed to run the virtio PMD to connect to the VFs on the NIC. The patch will add 
support for rte_flow commands in the virtio PMD. rte_flow is not supported in the stock DPDK. 
The rte_flow command must be used to setup flows to the VF and to offload flows to the NIC.


## How to apply the patch ##

The patch has to be used on a stock version of DPDK. It is not intended to be used on the Napatech version of DPDK.

## Clone DPDK ##
```
git clone https://dpdk.org/git/dpdk-stable dpdk
cd dpdk
git checkout v22.11.1
```

## Copy patch ##
Copy the patch into the dpdk directory.

## Apply the patch ##
```
patch -p1 < virtio_changes_22_11-v0_1.patch
```

## Run the patched virtio PMD ##
The patched virtio PMD can be run by using the following arguments

```
--no-pci 
--vdev=virtio_user0,path=/usr/local/var/run/stdvio4,server=1,mac=52:54:00:12:34:59,packed_vq=1 
--vdev=virtio_user1,path=/usr/local/var/run/stdvio5,server=1,mac=52:54:00:12:34:58,packed_vq=1 
--file-prefix=container1 
--socket-mem=2048
```

This will:
1. Disable the PCI probing
2. Start the virtio_user0 PMD for VF4
3. Start the virtio_user1 PMD for VF5
4. Limit the DPDK resource use, so it is possible to run several instances of DPDK

An example:

```
./examples_v22.11.1/examples/build/forward --no-pci --vdev=virtio_user0,path=/usr/local/var/run/stdvio4,server=1,mac=52:54:00:12:34:59,packed_vq=1 --vdev=virtio_user1,path=/usr/local/var/run/stdvio5,server=1,mac=52:54:00:12:34:58,packed_vq=1 --file-prefix=container1 --socket-mem=2048
```


