/*
 * SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "ntconn_client.h"
#include "ntconnect_api_adapter.h"


struct cfg_data_s {
  struct ntc_nic_pci_ids_s *nics;
  struct ntc_adap_get_info_s *info;
  struct ntc_interfaces_s *ifs;

  int adap_sel;
};

# define PARAM_SIZE 96

static const char *const usages[] = {
  "The Config tool commands used to set/get port and adapter settings\n"
  "\n"
  "Syntax for set cmd:\n"
  "---------------------\n"
  "\n"
  "  config  -s port<port number>,<enable|disable|link_state=up|link_state=down|link_speed=25G>\n"
  "\n"
  "Syntax for get cmd:\n"
  "---------------------\n"
  "\n"
  "  config  -g port<port number>,<link_speed|link_state>\n"
  "\n",
  NULL,
};

static const char *usageExamples =
  "\nImplemented -s (set) commands:\n"
  "* config -a 0 -s port0,enable\n"
  "* config -a 0 -s port0,disable\n"
  "* config -a 0 -s port1,link_state=up\n"
  "* config -a 0 -s port1,link_state=down\n"
  "* config -a 0 -s port0,link_speed=25G\n"
  "* config -a 0 -s port0,host_loopback=on\n"
  "* config -a 0 -s port0,line_loopback=on\n"
  "* config -a 0 -s port0,tx_power=on\n"
  "*\n"
  "*\n"
  "Implemented -g (get) commands:\n"
  "* config -g port1,link_speed\n"
  "* config -g port1,link_state\n"
  "* config -g port1,nim\n"
  "* config -g port1,port_state\n"
   "*\n";

#endif /* _CONFIG_H_ */
